std::reference_wrapper< _Tp > Class Template Reference
Utilities » Metaprogramming | Utilities » Function Objects

`#include <refwrap.h>`

Inherits std::_Reference_wrapper_base_memfun< _Tp, bool >.

## Public Types

typedef _Tp | type

## Public Member Functions

template<typename _Up , typename = __not_same<_Up>, typename = decltype(reference_wrapper::_S_fun(std::declval<_Up>()))>
| reference_wrapper (_Up &&__uref) noexcept(noexcept(reference_wrapper::_S_fun(std::declval< _Up >())))
| reference_wrapper (const reference_wrapper &)=default
_Tp & | get () const noexcept
| operator _Tp & () const noexcept
template<typename... _Args>
result_of< _Tp &(_Args &&...)>::type | operator() (_Args &&... __args) const
reference_wrapper & | operator= (const reference_wrapper &)=default

## Detailed Description

template<typename _Tp>
class std::reference_wrapper< _Tp >

Primary class template for reference_wrapper.

Definition at line 291 of file refwrap.h.

## Member Typedef Documentation

## type

template<typename _Tp >

typedef _Tp std::reference_wrapper< _Tp >::type

Definition at line 308 of file refwrap.h.

## Constructor & Destructor Documentation

## reference_wrapper()

template<typename _Tp >
template<typename _Up , typename = __not_same<_Up>, typename = decltype(reference_wrapper::_S_fun(std::declval<_Up>()))>

std::reference_wrapper< _Tp >::reference_wrapper | ( | _Up && | __uref | ) |

inline noexcept

Definition at line 315 of file refwrap.h.

## Member Function Documentation

## get()

template<typename _Tp >

_Tp & std::reference_wrapper< _Tp >::get | ( |  | ) | const

inline noexcept

Definition at line 329 of file refwrap.h.

## operator _Tp &()

template<typename _Tp >

std::reference_wrapper< _Tp >::operator _Tp & | ( |  | ) | const

inline noexcept

Definition at line 325 of file refwrap.h.

## operator()()

template<typename _Tp >
template<typename... _Args>

result_of< _Tp &(_Args &&...)>::type std::reference_wrapper< _Tp >::operator() | ( | _Args &&... | __args | ) | const

inline

Definition at line 334 of file refwrap.h.

The documentation for this class was generated from the following files:

- type_traits
- refwrap.h